package de.unikoblenz.fgbks.base.utils.boundary.checker;

import de.unikoblenz.fgbks.base.utils.boundary.AbstractGrowingBoundary;

public class CheckIsSubsumption extends AbstractBoundaryCheck<AbstractGrowingBoundary> {

  private static final CheckIsSubsumption instance = new CheckIsSubsumption();

  private CheckIsSubsumption() {
    super();
  }

  public static CheckIsSubsumption getInstance() {
    return instance;
  }

  @Override
  public BoundaryCheckType getType() {
    return BoundaryCheckType.IS_SUBSUMPTION;
  }

  @Override
  public boolean check(AbstractGrowingBoundary b1, AbstractGrowingBoundary b2) {
    return checkIsSubsumption(b1, b2);
  }

  public static boolean checkIsSubsumption(AbstractGrowingBoundary b1, AbstractGrowingBoundary b2) {
    return CheckSubsumes.checkSubsumes(b1, b2) || CheckSubsumes.checkSubsumes(b2, b1);
  }
}
